#include <cstdio>
#include <iostream>
#include "../include/flexfloat_st.hpp"


int main() 
{
    ff_st_init(-1); 

    printf("------------------------------------------\n");
    printf("|  Polynomial function of two variables  |\n");
    printf("|  with SAFE software                    |\n");
    printf("------------------------------------------\n");

    flexfloat_st<11, 52> x = 77617.;
    flexfloat_st<11, 52> y = 33096.;
    flexfloat_st<11, 52> res;

    res=333.75*y*y*y*y*y*y+x*x*(11.*x*x*y*y-y*y*y*y*y*y-121.*y*y*y*y-2.)   
        +5.5*y*y*y*y*y*y*y*y+x/(2.*y);

    std::cout << "res: " << res << "\n";
    printf("Exact result: -0.82739605994682...\n");

    ff_st_end();
    return 0;
}

