#include <math.h>
#include <stdio.h>
#include "../include/flexfloat_st.hpp"

int main()
{
  int i, nmax=100;
  flexfloat_st<11,52> y, x;
  
  ff_st_init(-1);

  printf("-------------------------------------------------------------\n");
  printf("|  Computation of a root of a polynomial by Newton's method |\n");
  printf("|  with optimization and SAFE software                      |\n");
  printf("-------------------------------------------------------------\n");
  
  y = 0.5;
  for(i = 1;i<=nmax;i++){
    x = y;
    y = ((4.2*x + 3.5)*x + 1.5)/(6.3*x + 6.1);
    if (x==y)break;
  }
  printf("x(%3d) = %s\n",i-1,strp(x)); 
  printf("x(%3d) = %s\n",i, strp(y));  

  ff_st_end();
}







