#include <cstdio>
#include <iostream>
#include "../include/flexfloat_st.hpp"


int main() 
{
    ff_st_init(-1); 

    printf("------------------------------------------\n");
    printf("|  Polynomial function of two variables  |\n");
    printf("|  with SAFE software                    |\n");
    printf("------------------------------------------\n");

    flexfloat_st<15, 112> x = 77617.q;
    flexfloat_st<15, 112> y = 33096.q;
    flexfloat_st<15, 112> res;

    res=333.75q*y*y*y*y*y*y+x*x*(11.q*x*x*y*y-y*y*y*y*y*y-121.q*y*y*y*y-2.q)   
        +5.5q*y*y*y*y*y*y*y*y+x/(2.q*y);

    std::cout << "res: " << res << "\n";
    printf("Exact result: -0.82739605994682...\n");

    ff_st_end();
    return 0;
}

