// Copyright 2024 Fabienne Jezequel, Ivan Lucas, Enzo Roaldes

// This file is part of SAFE.

// SAFE is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// SAFE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with SAFE.  If not, see <http://www.gnu.org/licenses/>.

#ifndef FF_ST_INTR_HPP
#define FF_ST_INTR_HPP

friend flexfloat_st<exp_bits, frac_bits> fabs(const flexfloat_st<exp_bits, frac_bits> &a)
{
    flexfloat_st<exp_bits, frac_bits> res;
    if (a.x >= 0)
    {
        res.x = a.x;
        if (_ff_st_intrinsic_tag)
            if ((a.y < 0) || (a.z < 0))
                instability(&_ff_st_intrinsic_count);
    }
    else
    {
        res.x = -a.x;
        if (_ff_st_intrinsic_tag)
            if ((a.y > 0) || (a.z > 0))
                instability(&_ff_st_intrinsic_count);
    }
    if (a.y >= 0)
        res.y = a.y;
    else
        res.y = -a.y;
    if (a.z >= 0)
        res.z = a.z;
    else
        res.z = -a.z;
    res.accuracy = DIGIT_NOT_COMPUTED;
    return (res);
}

#endif