// Copyright 2024 Fabienne Jezequel, Ivan Lucas, Enzo Roaldes

// This file is part of SAFE.

// SAFE is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// SAFE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with SAFE.  If not, see <http://www.gnu.org/licenses/>.

#ifndef RANDOM_ST_H
#define RANDOM_ST_H

// // The RANDOM BIT GENERATOR
extern unsigned short _st_random_table[];
extern unsigned int _st_table_counter;

void _st_init_table(unsigned int);

#define RANDOM_BIT_NUMBER 0x0000000F
#define RANDOM_ELEMENT_NUMBER 0x003FFFF0
#define RANDOM_ELEMENT_SHIFT 4

/// ne pas oublier _st_init_table
inline unsigned int random_st(void)
{
    const unsigned int part1 = _st_random_table[(_st_table_counter & RANDOM_ELEMENT_NUMBER) >> RANDOM_ELEMENT_SHIFT];
    const unsigned int part2 = (1 << ((_st_table_counter++) & RANDOM_BIT_NUMBER));
    return part1 & part2;
}
#define RANDOM random_st()

#endif