// Copyright 2024 Fabienne Jezequel, Ivan Lucas, Enzo Roaldes

// This file is part of SAFE.

// SAFE is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// SAFE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with SAFE.  If not, see <http://www.gnu.org/licenses/>.

#include <iostream>


int _ff_st_max_instability, _ff_st_instability_detected;
int nb_stability_count = 0;

unsigned long _ff_st_div_count;
unsigned long _ff_st_mul_count;  
unsigned long _ff_st_power_count;  
unsigned long _ff_st_math_count; 
unsigned long _ff_st_intrinsic_count;  
unsigned long _ff_st_cancel_count;  
unsigned long _ff_st_branching_count; 
#ifdef FF_ST_HALF_EMULATION
unsigned long _ff_st_half_overflow_count; 
unsigned long _ff_st_half_underflow_count; 
#endif

unsigned int _ff_st_div_tag=1;
unsigned int _ff_st_mul_tag=1;
unsigned int _ff_st_power_tag=1;
unsigned int _ff_st_math_tag=1;
unsigned int _ff_st_intrinsic_tag=1;
unsigned int _ff_st_cancel_tag=1;
unsigned int _ff_st_branching_tag=1;
#ifdef FF_ST_HALF_EMULATION
unsigned int _ff_st_half_overflow_tag=1; 
unsigned int _ff_st_half_underflow_tag=1; 
#endif

unsigned int _ff_st_div_change=0;
unsigned int _ff_st_mul_change=0;
unsigned int _ff_st_power_change=0;
unsigned int _ff_st_math_change=0;
unsigned int _ff_st_intrinsic_change=0;
unsigned int _ff_st_cancel_change=0;
unsigned int _ff_st_branching_change=0;
#ifdef FF_ST_HALF_EMULATION
unsigned int _ff_st_half_overflow_change=0; 
unsigned int _ff_st_half_underflow_change=0;
#endif

int _ff_st_cancel_value=4;

extern int _ff_st_cancel_value;

unsigned int _ff_st_random;
int _ff_st_random_counter;
unsigned int _ff_st_recurrence;

const char* _ff_st_div_err_msg       = "UNSTABLE DIVISION(S)";
const char* _ff_st_mul_err_msg       = "UNSTABLE MULTIPLICATION(S)";
const char* _ff_st_power_err_msg     = "UNSTABLE POWER FUNCTION(S)";
const char* _ff_st_branching_err_msg = "UNSTABLE BRANCHING(S)";
const char* _ff_st_cancel_err_msg    = "LOSS(ES) OF ACCURACY DUE TO CANCELLATION(S)";
const char* _ff_st_intrinsic_err_msg = "UNSTABLE INTRINSIC FUNCTION(S)";
const char* _ff_st_math_err_msg      = "UNSTABLE MATHEMATICAL FUNCTION(S)";
#ifdef FF_ST_HALF_EMULATION
const char* _ff_st_half_overflow_err_msg = "OVERFLOW(S) IS(ARE) DETECTED";
const char* _ff_st_half_underflow_err_msg = "UNDERFLOW(S) IS(ARE) DETECTED";
#endif
