// Copyright 2024 Fabienne Jezequel, Ivan Lucas, Enzo Roaldes

// This file is part of SAFE.

// SAFE is free software: you can redistribute it and/or modify
// it under the terms of the GNU Lesser General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// SAFE is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.

// You should have received a copy of the GNU Lesser General Public License
// along with SAFE.  If not, see <http://www.gnu.org/licenses/>.

#include <cstdio>
#include "../include/flexfloat_st.hpp"

void instability(unsigned long *unstab)
{
    (*unstab)++;
    _ff_st_instability_detected++;
    if (_ff_st_max_instability < 0)
        return;
    if (_ff_st_instability_detected == _ff_st_max_instability)
    {

        _ff_st_div_tag = 0;
        _ff_st_mul_tag = 0;
        _ff_st_power_tag = 0;
        _ff_st_math_tag = 0;
        _ff_st_intrinsic_tag = 0;
        _ff_st_cancel_tag = 0;
        _ff_st_branching_tag = 0;
        #ifdef FF_ST_HALF_EMULATION
        _ff_st_half_overflow_tag=0;
        _ff_st_half_underflow_tag=0;
        #endif



        _ff_st_div_change = 1;
        _ff_st_mul_change = 1;
        _ff_st_power_change = 1;
        _ff_st_branching_change = 1;
        _ff_st_cancel_change = 1;
        _ff_st_intrinsic_change = 1;
        _ff_st_math_change = 1;
        #ifdef FF_ST_HALF_EMULATION
        _ff_st_half_overflow_change=1;
        _ff_st_half_underflow_change=1;
        #endif

        _ff_st_max_instability = -2;
    }
}
